import { Search } from "@mui/icons-material"
import { TextField } from "@mui/material"

const PublicHeaderSearch = ({value, onChange}) => {

    return (
        <TextField
            label="search"
            variant="standard"
            type="search"
            value={value}
            onChange={onChange}
            sx={{flexGrow: 1, color:"white"}}
            InputLabelProps={{
            style: { color: 'rgba(255, 255, 255, 0.3)'},
  }}
        />
    )
}

export default PublicHeaderSearch